## wasmedge 0.14.1%2Bdfsg

=== lib/aot/CMakeLists.txt ===
# SPDX-License-Identifier: Apache-2.0
# SPDX-FileCopyrightText: 2019-2024 Second State INC

wasmedge_add_library(wasmedgeAOT
  blake3.cpp
  cache.cpp
)

target_link_libraries(wasmedgeAOT
  PUBLIC
  wasmedgeCommon
  wasmedgeSystem
  utilBlake3
  std::filesystem
)

target_include_directories(wasmedgeAOT
  SYSTEM
  PRIVATE
  ${LLVM_INCLUDE_DIR}
)

target_include_directories(wasmedgeAOT
  PUBLIC
  ${PROJECT_BINARY_DIR}/include
  ${PROJECT_SOURCE_DIR}/thirdparty/blake3
)

=== lib/common/CMakeLists.txt ===
# SPDX-License-Identifier: Apache-2.0
# SPDX-FileCopyrightText: 2019-2024 Second State INC

wasmedge_setup_spdlog()

wasmedge_add_library(wasmedgeCommon
  hexstr.cpp
  spdlog.cpp
  errinfo.cpp
)

target_link_libraries(wasmedgeCommon
  PUBLIC
  spdlog::spdlog
)

target_include_directories(wasmedgeCommon
  PUBLIC
  ${PROJECT_BINARY_DIR}/include
  ${PROJECT_SOURCE_DIR}/include
)

=== lib/executor/CMakeLists.txt ===
# SPDX-License-Identifier: Apache-2.0
# SPDX-FileCopyrightText: 2019-2024 Second State INC

wasmedge_add_library(wasmedgeExecutor
  instantiate/import.cpp
  instantiate/function.cpp
  instantiate/global.cpp
  instantiate/table.cpp
  instantiate/memory.cpp
  instantiate/elem.cpp
  instantiate/data.cpp
  instantiate/export.cpp
  instantiate/module.cpp
  instantiate/component.cpp
  instantiate/component/instantiate_component_alias.cpp
  instantiate/component/instantiate_component_canon.cpp
  instantiate/component/instantiate_component_export.cpp
  instantiate/component/instantiate_component_import.cpp
  instantiate/component/instantiate_component_instance.cpp
  instantiate/component/instantiate_component_start.cpp
  instantiate/component/instantiate_component_type.cpp
  instantiate/tag.cpp
  engine/proxy.cpp
  engine/controlInstr.cpp
  engine/tableInstr.cpp
  engine/threadInstr.cpp
  engine/memoryInstr.cpp
  engine/variableInstr.cpp
  engine/refInstr.cpp
  engine/engine.cpp
  helper.cpp
  executor.cpp
)

target_link_libraries(wasmedgeExecutor
  PUBLIC
  wasmedgeCommon
  wasmedgeSystem
)

=== plugins/wasmedge_process/CMakeLists.txt ===
# SPDX-License-Identifier: Apache-2.0
# SPDX-FileCopyrightText: 2019-2024 Second State INC

wasmedge_add_library(wasmedgePluginWasmEdgeProcess
  SHARED
  processenv.cpp
  processfunc.cpp
  processmodule.cpp
)

target_compile_options(wasmedgePluginWasmEdgeProcess
  PUBLIC
  -DWASMEDGE_PLUGIN
)

target_include_directories(wasmedgePluginWasmEdgeProcess
  PUBLIC
  $<TARGET_PROPERTY:wasmedgePlugin,INCLUDE_DIRECTORIES>
  ${CMAKE_CURRENT_SOURCE_DIR}
)

if(WASMEDGE_LINK_PLUGINS_STATIC)
  target_link_libraries(wasmedgePluginWasmEdgeProcess
    PRIVATE
    wasmedgeCAPI
  )
else()
  target_link_libraries(wasmedgePluginWasmEdgeProcess
    PRIVATE
    wasmedge_shared
  )
endif()

install(
  TARGETS wasmedgePluginWasmEdgeProcess
  DESTINATION ${CMAKE_INSTALL_LIBDIR}/wasmedge
)

=== tools/wasmedge/CMakeLists.txt ===
# SPDX-License-Identifier: Apache-2.0
# SPDX-FileCopyrightText: 2019-2024 Second State INC

if(WASMEDGE_USE_LLVM)
  wasmedge_add_executable(wasmedgec
    wasmedgec.cpp
  )

  install(TARGETS wasmedgec EXPORT wasmedge
    DESTINATION ${CMAKE_INSTALL_BINDIR}
  )

  if(WASMEDGE_LINK_TOOLS_STATIC)
    target_link_libraries(wasmedgec
      PRIVATE
      wasmedgeCAPI
    )
  else()
    target_link_libraries(wasmedgec
      PRIVATE
      wasmedge_shared
    )
  endif()
endif()

wasmedge_add_executable(wasmedge
  wasmedge.cpp
)

install(TARGETS wasmedge EXPORT wasmedge
  DESTINATION ${CMAKE_INSTALL_BINDIR}
)

if(WASMEDGE_LINK_TOOLS_STATIC)
  target_link_libraries(wasmedge
    PRIVATE
    wasmedgeCAPI
  )
else()
  target_link_libraries(wasmedge
    PRIVATE
    wasmedge_shared
  )
endif()


if(WASMEDGE_BUILD_WASI_NN_RPC)
  wasmedge_add_executable(wasi_nn_rpcserver
    wasi_nn_rpcserver.cpp
  )

  target_include_directories(wasi_nn_rpcserver
    SYSTEM BEFORE PUBLIC ${Protobuf_INCLUDE_DIR}
  )

  install(TARGETS wasi_nn_rpcserver EXPORT wasi_nn_rpcserver
    DESTINATION ${CMAKE_INSTALL_BINDIR}
  )

  if(WASMEDGE_LINK_TOOLS_STATIC)
    target_link_libraries(wasi_nn_rpcserver
      PRIVATE
      wasmedgeCAPI
    )
  else()
    target_link_libraries(wasi_nn_rpcserver
      PRIVATE
      wasmedge_shared
    )
  endif()

  target_compile_options(wasi_nn_rpcserver
    PUBLIC
    -DWASMEDGE_BUILD_WASI_NN_RPC
  )
endif()

=== debian/changelog ===
wasmedge (0.14.1+dfsg-3.1ubuntu2) resolute; urgency=medium

  * Rebuild against llvm 21

 -- Jeremy Bícha <jbicha@ubuntu.com>  Sat, 25 Oct 2025 05:04:05 -0400

wasmedge (0.14.1+dfsg-3.1ubuntu1) questing; urgency=medium

  * Fix FTBFS in questing due to LLVM 20 (LP: #2113496)
    - Remove-LLVMX86_MMXTypeKind-in-LLVM-20.patch

 -- Destiny Mora <destiny.mora4@gmail.com>  Sun, 08 Jun 2025 13:42:46 +0000

wasmedge (0.14.1+dfsg-3.1build1) plucky; urgency=medium

  * No-change rebuild for LLVM 20.

 -- Matthias Klose <doko@ubuntu.com>  Thu, 20 Feb 2025 22:01:33 +0100

wasmedge (0.14.1+dfsg-3.1) unstable; urgency=medium

  * Non-maintainer upload.
  * capi-wasi-env test: switch to wasm32-wasip1 target (Closes: #1093422)

 -- Fabian Grünbichler <debian@fabian.gruenbichler.email>  Tue, 21 Jan 2025 16:29:00 +0100

wasmedge (0.14.1+dfsg-3) unstable; urgency=medium

  * Fix an autopkgtest failure with test capi-mandelbrot, caused by a change
    in LLVM 19's defaults, by altering wasm-ld's --features argument.
    (Closes: #1086490)

 -- Faidon Liambotis <paravoid@debian.org>  Tue, 05 Nov 2024 14:34:36 +0200

wasmedge (0.14.1+dfsg-2) unstable; urgency=medium

  * Backport a (minor) upstream patch to fix a FTBFS with LLVM 19.
    (Closes: #1084396)

 -- Faidon Liambotis <paravoid@debian.org>  Mon, 07 Oct 2024 14:46:36 +0300

wasmedge (0.14.1+dfsg-1) unstable; urgency=medium

  * New upstream release.
    - Drop all existing debian/patches, all part of the new upstream release.
    - Backport upstream commit b96e895 (PR #3804) issue #3782) to address an
      fmt-v9-related FTBFS introduced with this release.

 -- Faidon Liambotis <paravoid@debian.org>  Fri, 04 Oct 2024 21:24:23 +0300

## wasmedge 0.14.1+dfsg

=== CMakeLists.txt ===
# SPDX-License-Identifier: Apache-2.0
# SPDX-FileCopyrightText: 2019-2024 Second State INC

cmake_minimum_required(VERSION 3.15)
cmake_policy(SET CMP0091 NEW)
if (CMAKE_VERSION VERSION_GREATER_EQUAL "3.24.0")
  cmake_policy(SET CMP0135 NEW)
endif()
project(WasmEdge LANGUAGES CXX C)

# CMake build type.
if(NOT CMAKE_BUILD_TYPE)
  set(CMAKE_BUILD_TYPE RelWithDebInfo)
endif()

# Overwrite it if you want to use static MSVC runtime library.
set(CMAKE_MSVC_RUNTIME_LIBRARY "MultiThreadedDLL")

# WasmEdge CAPI and so versions.
set(WASMEDGE_CAPI_VERSION "0.1.0" CACHE STRING "WasmEdge C API library version")
set(WASMEDGE_CAPI_SOVERSION "0" CACHE STRING "WasmEdge C API library soversion")
set(WASMEDGE_WASI_NN_VERSION "0.1.0" CACHE STRING "WasmEdge WASI-NN library version")
set(WASMEDGE_WASI_NN_SOVERSION "0" CACHE STRING "WasmEdge WASI-NN library soversion")

# Set cpack package version.
find_program(GIT_CMD git)
# Assuming the git command is not found and .git folder is not available.
set(GIT_VERSION_NOT_FOUND 1)
if(GIT_CMD AND EXISTS "${CMAKE_CURRENT_SOURCE_DIR}/.git")
  execute_process(COMMAND
    ${GIT_CMD} describe --match "[0-9].[0-9]*" --tag
    WORKING_DIRECTORY ${CMAKE_CURRENT_SOURCE_DIR}
    OUTPUT_VARIABLE CPACK_PACKAGE_VERSION
    RESULT_VARIABLE GIT_VERSION_NOT_FOUND
    OUTPUT_STRIP_TRAILING_WHITESPACE
  )
endif()
if(GIT_VERSION_NOT_FOUND AND NOT GIT_VERSION_NOT_FOUND EQUAL 0)
  set(CPACK_PACKAGE_VERSION "0.0.0-unreleased")
endif()

# Overwrite version information once there is a VERSION file.
if(EXISTS "${CMAKE_CURRENT_SOURCE_DIR}/VERSION")
  file(READ "${CMAKE_CURRENT_SOURCE_DIR}/VERSION" LOCAL_VERSION)
  set(CPACK_PACKAGE_VERSION ${LOCAL_VERSION})
  unset(LOCAL_VERSION)
endif()

# Add the CMake module path.
list(APPEND CMAKE_MODULE_PATH "${CMAKE_CURRENT_LIST_DIR}/cmake")

# Export compile commands.
set(CMAKE_EXPORT_COMPILE_COMMANDS ON)

# Find threads and filesystem.
set(THREADS_PREFER_PTHREAD_FLAG ON)
find_package(Filesystem REQUIRED Final Experimental)
find_package(Threads REQUIRED)

# List of WasmEdge options
option(WASMEDGE_BUILD_TESTS "Generate build targets for the wasmedge unit tests." OFF)
option(WASMEDGE_BUILD_COVERAGE "Generate coverage report. Require WASMEDGE_BUILD_TESTS." OFF)
option(WASMEDGE_BUILD_SHARED_LIB "Generate the WasmEdge shared library." ON)
option(WASMEDGE_BUILD_STATIC_LIB "Generate the WasmEdge static library." OFF)
option(WASMEDGE_BUILD_TOOLS "Generate wasmedge and wasmedgec tools. Depend on and will build the WasmEdge shared library." ON)
option(WASMEDGE_BUILD_FUZZING "Generate fuzzing test tools. Couldn't build with wasmedge tools and unit tests." OFF)
option(WASMEDGE_BUILD_PLUGINS "Generate plugins." ON)
option(WASMEDGE_BUILD_EXAMPLE "Generate examples." OFF)
option(WASMEDGE_BUILD_WASI_NN_RPC "Generate WASI-NN RPC." OFF)
option(WASMEDGE_USE_LLVM "Enable WasmEdge LLVM-based compilation runtime." ON)
if(WASMEDGE_BUILD_AOT_RUNTIME)
  message(WARNING "WASMEDGE_BUILD_AOT_RUNTIME option was renamed to WASMEDGE_USE_LLVM.")
  set(WASMEDGE_USE_LLVM "${WASMEDGE_BUILD_AOT_RUNTIME}" CACHE STRING "Enable WasmEdge LLVM-based compilation runtime.")
  unset(WASMEDGE_BUILD_AOT_RUNTIME CACHE)
endif()
option(WASMEDGE_FORCE_DISABLE_LTO "Forcefully disable link time optimization when linking even in Release/RelWithDeb build." OFF)
option(WASMEDGE_LINK_LLVM_STATIC "Statically link the LLVM library into the WasmEdge tools and libraries." OFF)
option(WASMEDGE_LINK_TOOLS_STATIC "Statically link the wasmedge and wasmedgec tools. Will forcefully link the LLVM library statically." OFF)
option(WASMEDGE_ENABLE_UB_SANITIZER "Enable undefined behavior sanitizer." OFF)
option(WASMEDGE_DISABLE_LIBTINFO "Disable linking against libtinfo when linking LLVM." OFF)

# Options about plug-ins.
#   WASI plug-in: WASI-Crypto proposal.
option(WASMEDGE_PLUGIN_WASI_CRYPTO "Enable and build WasmEdge wasi-crypto plugin." OFF)
#   WASI plug-in: WASI-Http proposal.
option(WASMEDGE_PLUGIN_WASI_HTTP "Enable and build WasmEdge wasi-http plugin." OFF)
#   WASI plug-in: WASI-Logging proposal.
#     Note: WASMEDGE_PLUGIN_WASI_LOGGING is not used until the new plug-in mechanism ready in 0.15.0.
option(WASMEDGE_PLUGIN_WASI_LOGGING "Enable and build WasmEdge wasi-logging plugin." ON)
#   WASI plug-in: WASI-NN proposal with backends.
set(WASMEDGE_PLUGIN_WASI_NN_BACKEND "" CACHE STRING "Enable and build WasmEdge Wasi-NN plugin with backends.")
option(WASMEDGE_PLUGIN_WASI_NN_GGML_LLAMA_NATIVE "Enable LLAMA_NATIVE(AVX/AVX2/FMA) in the WASI-NN GGML backend." ON)
option(WASMEDGE_PLUGIN_WASI_NN_GGML_LLAMA_BLAS "Enable LLAMA_BLAS in the WASI-NN GGML backend." OFF)
option(WASMEDGE_PLUGIN_WASI_NN_GGML_LLAMA_CUBLAS "Enable LLAMA_CUBLAS in the WASI-NN GGML backend." OFF)
option(WASMEDGE_PLUGIN_WASI_NN_GGML_LLAMA_METAL "Enable LLAMA_METAL in the WASI-NN GGML backend. Available on MacOS arm64 only." ON)
set(WASMEDGE_PLUGIN_WASI_NN_BURNRS_MODEL "" CACHE STRING "Enable WasmEdge WASI-NN Burn.rs backend with model.")
#   WASI plug-in: WASI-Poll proposal.
option(WASMEDGE_PLUGIN_WASI_POLL "Enable and build WasmEdge wasi-poll plugin." OFF)
#   WasmEdge plug-in: wasm-bpf.
option(WASMEDGE_PLUGIN_WASM_BPF "Enable and build WasmEdge wasm-bpf plugin." OFF)
#   WasmEdge plug-in: ffmpeg.
option(WASMEDGE_PLUGIN_FFMPEG "Enable and build WasmEdge ffmpeg plugin." OFF)
#   WasmEdge plug-in: Image.
option(WASMEDGE_PLUGIN_IMAGE "Enable and build WasmEdge image plugin." OFF)
#   WasmEdge plug-in: LLMC.
option(WASMEDGE_PLUGIN_LLMC "Enable and build WasmEdge LLMC plugin." OFF)
#   WasmEdge plug-in: OCR.
option(WASMEDGE_PLUGIN_OCR "Enable and build WasmEdge OCR plugin." OFF)
#   WasmEdge plug-in: OpenCV-mini.
option(WASMEDGE_PLUGIN_OPENCVMINI "Enable and build WasmEdge opencvmini plugin." OFF)
#   WasmEdge plug-in: Process.
option(WASMEDGE_PLUGIN_PROCESS "Enable and build WasmEdge process plugin." OFF)
#   WasmEdge plug-in: Stable-diffusion.
option(WASMEDGE_PLUGIN_STABLEDIFFUSION "Enable and build WasmEdge stable-diffusion plugin." OFF)
option(WASMEDGE_PLUGIN_STABLEDIFFUSION_CUBLAS "Enable CUBLAS in the stable-diffusion plugin." OFF)
option(WASMEDGE_PLUGIN_STABLEDIFFUSION_METAL "Enable Metal in the stable-diffusion plugin." OFF)
#   WasmEdge plug-in: TensorFlow.
option(WASMEDGE_PLUGIN_TENSORFLOW "Enable and build WasmEdge TensorFlow plugin." OFF)
#   WasmEdge plug-in: TensorFlow-Lite.
option(WASMEDGE_PLUGIN_TENSORFLOWLITE "Enable and build WasmEdge TensorFlow-Lite plugin." OFF)
#   WasmEdge plug-in: zlib.
option(WASMEDGE_PLUGIN_ZLIB "Enable and build WasmEdge zlib plugin." OFF)

# Fuzzing and tools and tests are exclusive.
if(WASMEDGE_BUILD_TOOLS AND WASMEDGE_BUILD_FUZZING)
  message(FATAL_ERROR "wasmedge tool and fuzzing tool are exclusive options.")
endif()
if(WASMEDGE_BUILD_TESTS AND WASMEDGE_BUILD_FUZZING)
  message(FATAL_ERROR "unit tests and fuzzing tool are exclusive options.")
endif()

# Static library will forcefully turn off the LTO.
if(WASMEDGE_BUILD_STATIC_LIB)
  set(WASMEDGE_FORCE_DISABLE_LTO ON)
endif()

# WasmEdge tool options.
if(WASMEDGE_BUILD_TOOLS)
  if(WASMEDGE_LINK_TOOLS_STATIC)
    # Static tools will link LLVM statically.
    set(WASMEDGE_LINK_LLVM_STATIC ON)
    # Tools will forcefully turn on the static library building.
    set(WASMEDGE_BUILD_STATIC_LIB ON)
    if(WASMEDGE_BUILD_PLUGINS)
      message(WARNING "For tuning on the WASMEDGE_LINK_TOOLS_STATIC option, the plugins will not work.")
    endif()
  else()
    # Tools will forcefully turn on the shared library building.
    set(WASMEDGE_BUILD_SHARED_LIB ON)
  endif()
endif()

if(WASMEDGE_BUILD_WASI_NN_RPC)
  # * Homebrew: grpc
  # * Debian, Ubuntu: libgrpc-dev, libgrpc++-dev
  find_package(PkgConfig)
  if(PkgConfig_FOUND)
    pkg_check_modules(gRPCPP grpc++)
  endif()
  # Do not check find_package(gRPC), because libgrpc-dev for Ubuntu 22.04 does not contain cmake files.
  # https://packages.ubuntu.com/search?keywords=libgrpc-dev
  # Do not check find_package(protobuf), because libprotobuf-dev for Ubuntu does not contain cmake files.
  # https://bugs.debian.org/cgi-bin/bugreport.cgi?bug=1027876
  if(gRPCPP_FOUND AND WASMEDGE_BUILD_SHARED_LIB)
    message(STATUS "If you see an error related to gRPC or protobuf, try setting WASMEDGE_BUILD_WASI_NN_RPC to OFF.")
  endif()
  if(WASMEDGE_BUILD_WASI_NN_RPC AND NOT WASMEDGE_BUILD_SHARED_LIB)
    message(FATAL_ERROR "WASMEDGE_BUILD_WASI_NN_RPC depends on WASMEDGE_BUILD_SHARED_LIB.")
  endif()
endif()

set(WASMEDGE_BUILD_PACKAGE "DEB;RPM" CACHE STRING "Package generate types")
set(CPACK_PROJECT_CONFIG_FILE ${CMAKE_CURRENT_SOURCE_DIR}/cmake/cpack_config.cmake)

if(WASMEDGE_BUILD_COVERAGE)
  set(GCOVR_ADDITIONAL_ARGS "--exclude-unreachable-branches;--exclude-throw-branches")
  include(CodeCoverage)
  append_coverage_compiler_flags()
endif()

include(FetchContent)
include(Helper)
include(GNUInstallDirs)

string(TOUPPER "${CMAKE_INSTALL_DEFAULT_COMPONENT_NAME}" CMAKE_INSTALL_DEFAULT_COMPONENT_NAME_UPCASE)
set(CPACK_PACKAGE_VENDOR Second State LLC)
set(CPACK_PACKAGE_FILE_NAME "${CMAKE_PROJECT_NAME}-${CPACK_PACKAGE_VERSION}-${CMAKE_SYSTEM_NAME}")
set(CPACK_STRIP_FILES ON)
set(CPACK_PACKAGE_CONTACT "Shen-Ta Hsieh <beststeve@secondstate.io>")
set(CPACK_PACKAGE_DESCRIPTION_SUMMARY "High performance WebAssembly Virtual Machine")
set(CPACK_ARCHIVE_COMPONENT_INSTALL ON)
set(CPACK_ARCHIVE_${CMAKE_INSTALL_DEFAULT_COMPONENT_NAME_UPCASE}_FILE_NAME "${CPACK_PACKAGE_FILE_NAME}")
set(CPACK_RPM_COMPONENT_INSTALL ON)
set(CPACK_RPM_MAIN_COMPONENT ${CMAKE_INSTALL_DEFAULT_COMPONENT_NAME})
set(CPACK_RPM_PACKAGE_LICENSE "Apache 2.0")
set(CPACK_DEB_COMPONENT_INSTALL ON)
set(CPACK_DEBIAN_${CMAKE_INSTALL_DEFAULT_COMPONENT_NAME_UPCASE}_PACKAGE_NAME wasmedge)
set(CPACK_DEBIAN_FILE_NAME DEB-DEFAULT)
set(CPACK_DEBIAN_COMPRESSION_TYPE xz)
set(CPACK_DEBIAN_PACKAGE_HOMEPAGE "https://github.com/WasmEdge/WasmEdge/")
set(CPACK_DEBIAN_PACKAGE_SHLIBDEPS ON)
set(CPACK_DEBIAN_PACKAGE_CONTROL_STRICT_PERMISSION ON)
set(CPACK_GENERATOR "${WASMEDGE_BUILD_PACKAGE}")
set(CPACK_PACKAGE_DESCRIPTION "WasmEdge is a high performance, extensible, and hardware optimized WebAssembly Virtual Machine for cloud, AI, and blockchain applications.")

if(WASMEDGE_BUILD_TESTS)
  include(CTest)
  add_subdirectory(test)
endif()

add_subdirectory(include)
add_subdirectory(lib)
if(WASMEDGE_BUILD_PLUGINS AND (WASMEDGE_BUILD_STATIC_LIB OR WASMEDGE_BUILD_SHARED_LIB))
  # Plug-ins should depend on the WasmEdge library.
  if(WASMEDGE_BUILD_STATIC_LIB AND NOT WASMEDGE_BUILD_SHARED_LIB)
    # Link to the static library if only the WasmEdge static library is built.
    # If the WasmEdge shared library is built, the plug-ins will link to the shared library.
    set(WASMEDGE_LINK_PLUGINS_STATIC ON)
  endif()
  add_subdirectory(plugins)
endif()
add_subdirectory(thirdparty)
if(WASMEDGE_BUILD_TOOLS OR WASMEDGE_BUILD_FUZZING)
  add_subdirectory(tools)
endif()
if(WASMEDGE_BUILD_EXAMPLE)
  add_subdirectory(examples/plugin/get-string)
endif()

include(CPack)
include(CPackComponent)

=== include/CMakeLists.txt ===
# SPDX-License-Identifier: Apache-2.0
# SPDX-FileCopyrightText: 2019-2024 Second State INC

string(REGEX MATCH "^([0-9]+)[.]([0-9]+)[.]([0-9]+)*"
    WASMEDGE_VERSION_STRING
    "${CPACK_PACKAGE_VERSION}"
)
string(REPLACE "." ";" WASMEDGE_VERSION_LIST ${WASMEDGE_VERSION_STRING})
list(GET WASMEDGE_VERSION_LIST 0 WASMEDGE_VERSION_MAJOR)
list(GET WASMEDGE_VERSION_LIST 1 WASMEDGE_VERSION_MINOR)
list(GET WASMEDGE_VERSION_LIST 2 WASMEDGE_VERSION_PATCH)
set(WASMEDGE_API_VERSION "4")

# Check the MMAP and PWD exists.
include(CheckCXXSymbolExists)
check_cxx_symbol_exists(mmap sys/mman.h HAVE_MMAP)
include(CheckIncludeFileCXX)
CHECK_INCLUDE_FILE_CXX(pwd.h HAVE_PWD_H)

configure_file(api/wasmedge/int128.h api/wasmedge/int128.h COPYONLY)
configure_file(api/wasmedge/version.h.in api/wasmedge/version.h)
configure_file(api/wasmedge/wasmedge.h api/wasmedge/wasmedge.h COPYONLY)
configure_file(common/config.h.in common/config.h)
configure_file(common/enum.inc api/wasmedge/enum.inc COPYONLY)
configure_file(common/enum_configure.h api/wasmedge/enum_configure.h COPYONLY)
configure_file(common/enum_errcode.h api/wasmedge/enum_errcode.h COPYONLY)
configure_file(common/enum_types.h api/wasmedge/enum_types.h COPYONLY)
configure_file(common/version.h.in common/version.h)
unset(WASMEDGE_VERSION_STRING)
unset(WASMEDGE_VERSION_LIST)
unset(WASMEDGE_VERSION_MAJOR)
unset(WASMEDGE_VERSION_MINOR)
unset(WASMEDGE_VERSION_PATCH)
unset(WASMEDGE_API_VERSION)

=== lib/CMakeLists.txt ===
# SPDX-License-Identifier: Apache-2.0
# SPDX-FileCopyrightText: 2019-2024 Second State INC

if(WASMEDGE_USE_LLVM)
  add_subdirectory(aot)
  add_subdirectory(llvm)
endif()
add_subdirectory(common)
add_subdirectory(system)
add_subdirectory(plugin)
add_subdirectory(po)
add_subdirectory(loader)
add_subdirectory(validator)
add_subdirectory(executor)
add_subdirectory(host)
add_subdirectory(vm)
add_subdirectory(driver)
if(WASMEDGE_BUILD_SHARED_LIB OR WASMEDGE_BUILD_STATIC_LIB OR WASMEDGE_BUILD_TOOLS)
  add_subdirectory(api)
endif()
if(WASMEDGE_BUILD_WASI_NN_RPC)
  add_subdirectory(wasi_nn_rpc)
endif()

=== plugins/CMakeLists.txt ===
# SPDX-License-Identifier: Apache-2.0
# SPDX-FileCopyrightText: 2019-2024 Second State INC

# WASI plug-in: WASI-Crypto proposal.
if(WASMEDGE_PLUGIN_WASI_CRYPTO)
  add_subdirectory(wasi_crypto)
endif()

# WASI plug-in: WASI-Http proposal.
if(WASMEDGE_PLUGIN_WASI_HTTP)
  add_subdirectory(wasi_http)
endif()

# WASI plug-in: WASI-Logging proposal.
if(WASMEDGE_PLUGIN_WASI_LOGGING)
  # BUILTIN-PLUGIN: Add the wasi-logging plugin here after the new plugin
  # architecture ready in 0.15.0.
endif()

# WASI plug-in: WASI-NN proposal with backends.
if(WASMEDGE_PLUGIN_WASI_NN_BACKEND)
  add_subdirectory(wasi_nn)
endif()
if(WASMEDGE_PLUGIN_WASI_NN_BURNRS_MODEL)
  add_subdirectory(wasi_nn_burnrs)
endif()

# WASI plug-in: WASI-Poll proposal.
if(WASMEDGE_PLUGIN_WASI_POLL)
  add_subdirectory(wasi_poll)
endif()

# WasmEdge plug-in: wasm-bpf.
if(WASMEDGE_PLUGIN_WASM_BPF)
  # Only Linux systems support wasm_bpf now.
  if(CMAKE_SYSTEM_NAME MATCHES "Linux")
    add_subdirectory(wasm_bpf)
  else()
    message(WARNING "Only Linux platforms support wasm_bpf plug-in now.")
  endif()
endif()

# WasmEdge plug-in: ffmpeg.
if(WASMEDGE_PLUGIN_FFMPEG)
  add_subdirectory(wasmedge_ffmpeg)
endif()

# WasmEdge plug-in: Image.
if(WASMEDGE_PLUGIN_IMAGE)
  # Only Linux and MacOS support wasmedge_image now.
  if(CMAKE_SYSTEM_NAME MATCHES "Linux|Darwin")
    add_subdirectory(wasmedge_image)
  else()
    message(WARNING "Only Linux and Darwin platforms support WasmEdge_Image plug-in now.")
  endif()
endif()

# WasmEdge plug-in: LLMC.
if(WASMEDGE_PLUGIN_LLMC)
  add_subdirectory(wasmedge_llmc)
endif()

# WasmEdge plug-in: OCR.
if(WASMEDGE_PLUGIN_OCR)
  add_subdirectory(wasmedge_ocr)
endif()

# WasmEdge plug-in: OpenCV-mini.
if(WASMEDGE_PLUGIN_OPENCVMINI)
  # Only Linux and MacOS support wasmedge_opencvmini now.
  if(CMAKE_SYSTEM_NAME MATCHES "Linux|Darwin")
    add_subdirectory(wasmedge_opencvmini)
  else()
    message(WARNING "Only Linux and Darwin platforms support WasmEdge_OpenCVMini plug-in now.")
  endif()
endif()

# WasmEdge plug-in: Process.
if(WASMEDGE_PLUGIN_PROCESS)
  # Only Linux systems support wasmedge_process now.
  if(CMAKE_SYSTEM_NAME MATCHES "Linux")
    add_subdirectory(wasmedge_process)
  else()
    message(WARNING "Only Linux platforms support WasmEdge_Process plug-in now.")
  endif()
endif()

# WasmEdge plug-in: Stable-diffusion.
if(WASMEDGE_PLUGIN_STABLEDIFFUSION)
  # Only Linux and MacOS support wasmedge_stablediffusion now.
  if(CMAKE_SYSTEM_NAME MATCHES "Linux|Darwin")
    add_subdirectory(wasmedge_stablediffusion)
  else()
    message(WARNING "Only Linux and Darwin platforms support WasmEdge_StableDiffusion plug-in now.")
  endif()
endif()

# WasmEdge plug-in: TensorFlow.
if(WASMEDGE_PLUGIN_TENSORFLOW)
  # Only Linux and MacOS support wasmedge_tensorflow now.
  if(CMAKE_SYSTEM_NAME MATCHES "Linux|Darwin")
    add_subdirectory(wasmedge_tensorflow)
  else()
    message(WARNING "Only Linux and Darwin platforms support WasmEdge_Tensorflow plug-in now.")
  endif()
endif()

# WasmEdge plug-in: TensorFlow-Lite.
if(WASMEDGE_PLUGIN_TENSORFLOWLITE)
  # Only Linux and MacOS support wasmedge_tensorflowlite now.
  if(CMAKE_SYSTEM_NAME MATCHES "Linux|Darwin")
    add_subdirectory(wasmedge_tensorflowlite)
  else()
    message(WARNING "Only Linux and Darwin platforms support WasmEdge_TensorflowLite plug-in now.")
  endif()
endif()

# WasmEdge plug-in: zlib.
if(WASMEDGE_PLUGIN_ZLIB)
  add_subdirectory(wasmedge_zlib)
endif()

=== test/CMakeLists.txt ===
# SPDX-License-Identifier: Apache-2.0
# SPDX-FileCopyrightText: 2019-2024 Second State INC

find_package(GTest QUIET)
if(GTest_FOUND)
  set(GTEST_BOTH_LIBRARIES "${GTEST_BOTH_LIBRARIES};Threads::Threads")
else()
  FetchContent_Declare(
    GTest
    GIT_REPOSITORY https://github.com/google/googletest.git
    GIT_TAG v1.15.2
    GIT_SHALLOW TRUE
  )
  set(BUILD_GMOCK OFF CACHE BOOL "Builds the googlemock subproject" FORCE)
  set(INSTALL_GTEST OFF CACHE BOOL "Enable installation of googletest. (Projects embedding googletest may want to turn this OFF.)" FORCE)
  if(CMAKE_CXX_COMPILER_ID MATCHES "MSVC")
    add_compile_options(
      ${WASMEDGE_CFLAGS}
    )
  else()
    add_compile_options(
      ${WASMEDGE_CFLAGS}
      -Wno-language-extension-token
      -Wno-missing-noreturn
      -Wno-shift-sign-overflow
      -Wno-undef
      -Wno-unused-member-function
      $<$<COMPILE_LANGUAGE:CXX>:-Wno-zero-as-null-pointer-constant>
      -Wno-deprecated
    )
    if(NOT CMAKE_CXX_COMPILER_ID STREQUAL "AppleClang")
      add_compile_options(
        -Wno-suggest-destructor-override
        $<$<COMPILE_LANGUAGE:CXX>:-Wno-suggest-override>
      )
    endif()
  endif()

  FetchContent_MakeAvailable(GTest)
  set(GTEST_BOTH_LIBRARIES "gtest;gtest_main")
endif()

if(WASMEDGE_USE_LLVM)
  add_subdirectory(aot)
  add_subdirectory(llvm)
  add_subdirectory(mixcall)
endif()
add_subdirectory(common)
add_subdirectory(spec)
add_subdirectory(loader)
add_subdirectory(executor)
add_subdirectory(thread)
if(WASMEDGE_BUILD_SHARED_LIB)
  add_subdirectory(api)
  add_subdirectory(externref)
endif()
if(WASMEDGE_BUILD_PLUGINS)
  add_subdirectory(plugins)
endif()
add_subdirectory(host/socket)
add_subdirectory(host/wasi)
add_subdirectory(host/mock)
add_subdirectory(expected)
add_subdirectory(span)
add_subdirectory(po)
add_subdirectory(memlimit)
add_subdirectory(errinfo)

if(WASMEDGE_BUILD_COVERAGE)
  setup_target_for_coverage_gcovr_html(
    NAME coverage
    EXECUTABLE ctest -j ${PROCESSOR_COUNT}
    DEPENDENCIES wasmedge
    BASE_DIRECTORY "${CMAKE_CURRENT_BINARY_DIR}"
    EXCLUDE
    "${PROJECT_SOURCE_DIR}/thirdparty/*"
    "${PROJECT_SOURCE_DIR}/test/*"
  )
  setup_target_for_coverage_gcovr_xml(
    NAME codecov
    EXECUTABLE ctest -j ${PROCESSOR_COUNT}
    DEPENDENCIES wasmedge
    EXCLUDE
    "${PROJECT_SOURCE_DIR}/thirdparty/*"
    "${PROJECT_SOURCE_DIR}/test/*"
  )
endif()

=== thirdparty/CMakeLists.txt ===
# SPDX-License-Identifier: Apache-2.0
# SPDX-FileCopyrightText: 2019-2024 Second State INC

if(WASMEDGE_USE_LLVM)
  add_subdirectory(blake3)
endif()

=== tools/CMakeLists.txt ===
# SPDX-License-Identifier: Apache-2.0
# SPDX-FileCopyrightText: 2019-2024 Second State INC

if(WASMEDGE_BUILD_TOOLS)
  add_subdirectory(wasmedge)
endif()
if(WASMEDGE_BUILD_FUZZING)
  add_subdirectory(fuzz)
endif()

=== examples/embed_cxx/CMakeLists.txt ===
cmake_minimum_required(VERSION 3.16)

project(embed_cxx CXX)

set(CMAKE_CXX_STANDARD 17)

set(WASMEDGE_SOURCE_DIR ${CMAKE_CURRENT_SOURCE_DIR}/../..)
set(WASMEDGE_USE_LLVM OFF)
if (CMAKE_GENERATOR STREQUAL Ninja)
  set(CMAKE_JOB_POOLS "link=2")
  set(CMAKE_JOB_POOL_LINK link)
endif()
add_subdirectory(${WASMEDGE_SOURCE_DIR} WasmEdge)
include_directories(${WasmEdge_BINARY_DIR}/include/api)

add_subdirectory(script)

add_executable(
    embed_cxx
    main.cpp
)

target_link_libraries(
    embed_cxx
    wasmedge_shared
    fibonacci
)

get_filename_component(WASI_SDK_HOME $ENV{WASI_SDK_HOME} ABSOLUTE)
message("WASI_SDK_HOME=${WASI_SDK_HOME}")
# download wasi-sdk
if (NOT EXISTS ${WASI_SDK_HOME})
    set(WASI_SDK_VERSION 14.0)
    set(WASI_SDK_PATH ${CMAKE_CURRENT_BINARY_DIR}/deps/wasi-sdk)
    set(WASI_SDK_HOME ${WASI_SDK_PATH}/wasi-sdk-${WASI_SDK_VERSION})

    if(NOT EXISTS "${WASI_SDK_HOME}/bin/clang")
        message("download wasi-sdk")
        if (${CMAKE_SYSTEM_NAME} MATCHES "Darwin")
            set(WASI_SDK_TARGET "darwin")
        elseif(${CMAKE_SYSTEM_NAME} MATCHES "Linux")
            set(WASI_SDK_TARGET "linux")
        elseif(${CMAKE_SYSTEM_NAME} MATCHES "Windows")
            set(WASI_SDK_TARGET "mingw")
        endif ()

        set(WASI_SDK_TARGZ_URL https://github.com/WebAssembly/wasi-sdk/releases/download/wasi-sdk-14/wasi-sdk-${WASI_SDK_VERSION}-${WASI_SDK_TARGET}.tar.gz)
        set(WASI_SDK_TARGZ_PATH ${CMAKE_CURRENT_BINARY_DIR}/wasi-sdk.tar.gz)
        file(DOWNLOAD ${WASI_SDK_TARGZ_URL} ${WASI_SDK_TARGZ_PATH} INACTIVITY_TIMEOUT 10)
        file(ARCHIVE_EXTRACT INPUT ${WASI_SDK_TARGZ_PATH} DESTINATION ${WASI_SDK_PATH})
    endif()
endif()

include(ExternalProject)
ExternalProject_Add(
        script_wasm
        SOURCE_DIR ${CMAKE_CURRENT_SOURCE_DIR}/script
        BINARY_DIR ${CMAKE_CURRENT_BINARY_DIR}/script_wasm
        CMAKE_CACHE_ARGS
        -DWASI_SDK_PREFIX:FILEPATH=${WASI_SDK_HOME}
        -DCMAKE_TOOLCHAIN_FILE:FILEPATH=${WASI_SDK_HOME}/share/cmake/wasi-sdk.cmake
        -DCMAKE_SYSROOT:FILEPATH=${WASI_SDK_HOME}/share/wasi-sysroot
        -DWASM_OUT_DIR:FILEPATH=${CMAKE_CURRENT_BINARY_DIR}
        INSTALL_COMMAND ""
        BUILD_ALWAYS 1
)

add_dependencies(
    embed_cxx
    script_wasm
)

=== lib/api/CMakeLists.txt ===
# SPDX-License-Identifier: Apache-2.0
# SPDX-FileCopyrightText: 2019-2024 Second State INC

find_package(spdlog QUIET)
add_definitions(-DWASMEDGE_COMPILE_LIBRARY)
if(WASMEDGE_USE_LLVM)
  add_definitions(-DWASMEDGE_USE_LLVM)
endif()
if(WASMEDGE_BUILD_WASI_NN_RPC)
  add_definitions(-DWASMEDGE_BUILD_WASI_NN_RPC)
endif()

get_filename_component(CMAKE_AR_NAME "${CMAKE_AR}" NAME)

# Helper function to construct commands and dependencies.
function(wasmedge_add_static_lib_component_command target)
  if(APPLE)
    if(CMAKE_AR_NAME STREQUAL "ar")
      list(APPEND CMDS
        COMMAND ${CMAKE_COMMAND} -E make_directory objs/${target}
        COMMAND ${CMAKE_AR} -x $<TARGET_FILE:${target}>
        COMMAND ${CMAKE_AR} -t $<TARGET_FILE:${target}> | xargs -I '{}' mv '{}' objs/${target}
      )
      set(WASMEDGE_STATIC_LIB_AR_CMDS ${WASMEDGE_STATIC_LIB_AR_CMDS} ${CMDS} PARENT_SCOPE)
    elseif(CMAKE_AR_NAME STREQUAL "libtool")
      set(WASMEDGE_STATIC_LIB_LIBTOOL_FILES ${WASMEDGE_STATIC_LIB_LIBTOOL_FILES} $<TARGET_FILE:${target}> PARENT_SCOPE)
    endif()
  else()
    list(APPEND CMDS
      COMMAND ${CMAKE_COMMAND} -E make_directory objs/${target}
      COMMAND ${CMAKE_COMMAND} -E chdir objs/${target} ${CMAKE_AR} -x $<TARGET_FILE:${target}>
    )
    set(WASMEDGE_STATIC_LIB_AR_CMDS ${WASMEDGE_STATIC_LIB_AR_CMDS} ${CMDS} PARENT_SCOPE)
  endif()
  set(WASMEDGE_STATIC_LIB_DEPS ${WASMEDGE_STATIC_LIB_DEPS} ${target} PARENT_SCOPE)
endfunction()

# Helper function to construct commands about packaging llvm and dependency libraries with paths.
function(wasmedge_add_libs_component_command target_path)
  get_filename_component(target_name ${target_path} NAME)
  string(REGEX REPLACE "^lib" "" target_name ${target_name})
  string(REGEX REPLACE "\.a$" "" target_name ${target_name})
  if(APPLE)
    get_filename_component(CMAKE_AR_NAME "${CMAKE_AR}" NAME)
    if(CMAKE_AR_NAME STREQUAL "ar")
      list(APPEND CMDS
        COMMAND ${CMAKE_COMMAND} -E make_directory objs/${target_name}
        COMMAND ${CMAKE_AR} -x ${target_path}
        COMMAND ${CMAKE_AR} -t ${target_path} | xargs -I '{}' mv '{}' objs/${target_name}
      )
      set(WASMEDGE_STATIC_LLVM_LIB_AR_CMDS ${WASMEDGE_STATIC_LLVM_LIB_AR_CMDS} ${CMDS} PARENT_SCOPE)
    elseif(CMAKE_AR_NAME STREQUAL "libtool")
      set(WASMEDGE_STATIC_LIB_LIBTOOL_FILES ${WASMEDGE_STATIC_LIB_LIBTOOL_FILES} ${target_path} PARENT_SCOPE)
    endif()
  else()
    list(APPEND CMDS
      COMMAND ${CMAKE_COMMAND} -E make_directory objs/${target_name}
      COMMAND ${CMAKE_COMMAND} -E chdir objs/${target_name} ${CMAKE_AR} -x ${target_path}
    )
    set(WASMEDGE_STATIC_LLVM_LIB_AR_CMDS ${WASMEDGE_STATIC_LLVM_LIB_AR_CMDS} ${CMDS} PARENT_SCOPE)
  endif()
endfunction()

set(WASMEDGE_CAPI_HEADERS
  ${CMAKE_CURRENT_SOURCE_DIR}/../../include/api/wasmedge/wasmedge.h
  ${CMAKE_CURRENT_BINARY_DIR}/../../include/api/wasmedge/version.h
  ${CMAKE_CURRENT_BINARY_DIR}/../../include/api/wasmedge/enum.inc
  ${CMAKE_CURRENT_BINARY_DIR}/../../include/api/wasmedge/enum_configure.h
  ${CMAKE_CURRENT_BINARY_DIR}/../../include/api/wasmedge/enum_errcode.h
  ${CMAKE_CURRENT_BINARY_DIR}/../../include/api/wasmedge/enum_types.h
  ${CMAKE_CURRENT_SOURCE_DIR}/../../include/api/wasmedge/int128.h
)

# Object library of the C API wrapper.
wasmedge_add_library(wasmedgeCAPI OBJECT
  wasmedge.cpp
)

target_link_libraries(wasmedgeCAPI
  PUBLIC
  wasmedgeVM
  wasmedgeDriver
)

if(WASMEDGE_USE_LLVM)
  target_link_libraries(wasmedgeCAPI
    PUBLIC
    wasmedgeAOT
    wasmedgeLLVM
  )
endif()

target_include_directories(wasmedgeCAPI
  PUBLIC
  ${PROJECT_BINARY_DIR}/include/api
  ${PROJECT_SOURCE_DIR}/include/api
)

if(WASMEDGE_BUILD_SHARED_LIB)
  wasmedge_add_library(wasmedge_shared SHARED
    ../../include/api/wasmedge/wasmedge.h
  )

  set_target_properties(wasmedge_shared PROPERTIES
    PUBLIC_HEADER "${WASMEDGE_CAPI_HEADERS}"
    VERSION "${WASMEDGE_CAPI_VERSION}"
    SOVERSION "${WASMEDGE_CAPI_SOVERSION}"
    OUTPUT_NAME wasmedge
  )

  if(CMAKE_SYSTEM_NAME MATCHES "Linux|Android")
    set_target_properties(wasmedge_shared PROPERTIES
      LINK_DEPENDS "${CMAKE_CURRENT_SOURCE_DIR}/libwasmedge.lds"
    )
    target_link_options(wasmedge_shared
      PRIVATE
      "-Wl,--version-script=${CMAKE_CURRENT_SOURCE_DIR}/libwasmedge.lds"
    )
  endif()

  target_link_libraries(wasmedge_shared
    PRIVATE
    wasmedgeCAPI
  )
  target_link_libraries(wasmedge_shared
    PUBLIC
    spdlog::spdlog
  )

  target_include_directories(wasmedge_shared
    PUBLIC
    ${PROJECT_BINARY_DIR}/include/api
    ${PROJECT_SOURCE_DIR}/include/api
  )

  install(TARGETS wasmedge_shared
    LIBRARY DESTINATION ${CMAKE_INSTALL_LIBDIR}
    PUBLIC_HEADER DESTINATION ${CMAKE_INSTALL_INCLUDEDIR}/wasmedge
  )
endif()

if(WASMEDGE_BUILD_STATIC_LIB)

  wasmedge_add_static_lib_component_command(spdlog::spdlog)
  wasmedge_add_static_lib_component_command(wasmedgeSystem)
  wasmedge_add_static_lib_component_command(wasmedgeCommon)
  wasmedge_add_static_lib_component_command(wasmedgePO)
  wasmedge_add_static_lib_component_command(wasmedgeLoaderFileMgr)
  wasmedge_add_static_lib_component_command(wasmedgeLoader)
  wasmedge_add_static_lib_component_command(wasmedgeValidator)
  wasmedge_add_static_lib_component_command(wasmedgeExecutor)
  wasmedge_add_static_lib_component_command(wasmedgeHostModuleWasi)
  wasmedge_add_static_lib_component_command(wasmedgePlugin)
  # BUILTIN-PLUGIN: Temporary add the wasi-logging plugin here until the new
  # plugin architecture ready in 0.15.0.
  wasmedge_add_static_lib_component_command(wasmedgePluginWasiLogging)
  wasmedge_add_static_lib_component_command(wasmedgeVM)
  wasmedge_add_static_lib_component_command(wasmedgeDriver)

  if(WASMEDGE_USE_LLVM)
    foreach(LIB_NAME IN LISTS WASMEDGE_LLVM_LINK_STATIC_COMPONENTS)
      wasmedge_add_libs_component_command(${LIB_NAME})
    endforeach()
    wasmedge_add_static_lib_component_command(utilBlake3)
    wasmedge_add_static_lib_component_command(wasmedgeAOT)
    wasmedge_add_static_lib_component_command(wasmedgeLLVM)
  endif()

  if(CMAKE_AR_NAME STREQUAL "libtool")
    add_custom_command(OUTPUT "libwasmedge.a"
      COMMAND ${CMAKE_AR} -static -o libwasmedge.a ${WASMEDGE_STATIC_LIB_LIBTOOL_FILES} $<TARGET_OBJECTS:wasmedgeCAPI>
      WORKING_DIRECTORY ${CMAKE_CURRENT_BINARY_DIR}
      DEPENDS ${WASMEDGE_STATIC_LIB_DEPS} wasmedgeCAPI
    )
  else()
    add_custom_command(OUTPUT "libwasmedge.a"
      ${WASMEDGE_STATIC_LIB_AR_CMDS}
      ${WASMEDGE_STATIC_LLVM_LIB_AR_CMDS}
      COMMAND ${CMAKE_AR} -qcs libwasmedge.a $<TARGET_OBJECTS:wasmedgeCAPI> objs/*/*.o
      COMMAND ${CMAKE_COMMAND} -E remove_directory objs
      WORKING_DIRECTORY ${CMAKE_CURRENT_BINARY_DIR}
      DEPENDS ${WASMEDGE_STATIC_LIB_DEPS} wasmedgeCAPI
    )
  endif()

  add_custom_target(wasmedge_static_target ALL DEPENDS "libwasmedge.a")
  add_library(wasmedge_static STATIC IMPORTED GLOBAL)
  add_dependencies(wasmedge_static wasmedge_static_target)

  set_target_properties(wasmedge_static
    PROPERTIES
    IMPORTED_LOCATION "${CMAKE_CURRENT_BINARY_DIR}/libwasmedge.a"
    INTERFACE_INCLUDE_DIRECTORIES ${PROJECT_BINARY_DIR}/include/api
  )

  install(FILES ${CMAKE_CURRENT_BINARY_DIR}/libwasmedge.a
    DESTINATION ${CMAKE_INSTALL_LIBDIR}
  )
  install(FILES ${WASMEDGE_CAPI_HEADERS}
    DESTINATION ${CMAKE_INSTALL_INCLUDEDIR}/wasmedge
  )
endif()

=== lib/driver/CMakeLists.txt ===
# SPDX-License-Identifier: Apache-2.0
# SPDX-FileCopyrightText: 2019-2024 Second State INC

set(SOURCES
  compilerTool.cpp
  runtimeTool.cpp
  fuzzTool.cpp
  fuzzPO.cpp
  uniTool.cpp
)

if(WASMEDGE_BUILD_WASI_NN_RPC)
  list(APPEND SOURCES wasiNNRPCServerTool.cpp)
endif()

wasmedge_add_library(wasmedgeDriver
  ${SOURCES}
)

if(WASMEDGE_BUILD_WASI_NN_RPC)
  target_link_libraries(wasmedgeDriver
    PRIVATE
    wasiNNRPC
  )
endif()

if(WASMEDGE_USE_LLVM)
  target_link_libraries(wasmedgeDriver
    PRIVATE
    wasmedgeLoader
    wasmedgeCommon
    wasmedgePO
    wasmedgeVM
    wasmedgeAOT
    wasmedgeLLVM
  )
else()
  target_link_libraries(wasmedgeDriver
    PRIVATE
    wasmedgeLoader
    wasmedgeCommon
    wasmedgePO
    wasmedgeVM
  )
endif()

if(WASMEDGE_USE_LLVM)
  target_compile_definitions(wasmedgeDriver
    PRIVATE
    -DWASMEDGE_USE_LLVM
  )
endif()

=== lib/host/CMakeLists.txt ===
# SPDX-License-Identifier: Apache-2.0
# SPDX-FileCopyrightText: 2019-2024 Second State INC

add_subdirectory(wasi)

=== lib/llvm/CMakeLists.txt ===
# SPDX-License-Identifier: Apache-2.0
# SPDX-FileCopyrightText: 2019-2024 Second State INC

find_package(LLVM REQUIRED HINTS "${LLVM_CMAKE_PATH}")
get_filename_component(LLVM_DIR "${LLVM_DIR}" ABSOLUTE)
list(APPEND CMAKE_MODULE_PATH ${LLVM_DIR})
include(LLVMConfig)
include(AddLLVM)

get_filename_component(LLD_DIR "${LLVM_LIBRARY_DIR}/cmake/lld" ABSOLUTE)
find_package(LLD REQUIRED HINTS ${LLD_DIR})

if(WASMEDGE_LINK_LLVM_STATIC)
  wasmedge_add_library(wasmedgeLLVM
    compiler.cpp
    codegen.cpp
    data.cpp
    jit.cpp
  )

  target_link_libraries(wasmedgeLLVM
    PUBLIC
    wasmedgeCommon
    wasmedgeSystem
    std::filesystem
    ${WASMEDGE_LLVM_LINK_STATIC_COMPONENTS}
    ${WASMEDGE_LLVM_LINK_SHARED_COMPONENTS}
  )
else()
  if(APPLE)
    list(APPEND LLD_LIBS lldMachO)
  elseif(WIN32)
    list(APPEND LLD_LIBS lldCOFF)
    set(EXTRA_COMPONENTS DebugInfoPDB LibDriver WindowsManifest)
  else()
    list(APPEND LLD_LIBS lldELF)
  endif()

  list(APPEND LLD_LIBS lldCommon)
  if(LLVM_VERSION_MAJOR LESS_EQUAL 13)
    list(APPEND LLD_LIBS lldDriver)
  endif()

  # Command line warning D9025 : overriding '/EHs' with '/EHs-'
  # prevent LLVM from adding /EHs-c-.
  if(WIN32)
    set(LLVM_REQUIRES_EH ON)
  endif()

  llvm_add_library(wasmedgeLLVM
    compiler.cpp
    codegen.cpp
    data.cpp
    jit.cpp
    LINK_LIBS
    wasmedgeCommon
    wasmedgeSystem
    ${LLD_LIBS}
    std::filesystem
    ${CMAKE_THREAD_LIBS_INIT}
    LINK_COMPONENTS
    core
    lto
    native
    nativecodegen
    option
    passes
    support
    orcjit
    transformutils
    ${EXTRA_COMPONENTS}
  )
endif()

wasmedge_setup_target(wasmedgeLLVM)

target_include_directories(wasmedgeLLVM
  SYSTEM
  PRIVATE
  ${LLVM_INCLUDE_DIR}
)

target_include_directories(wasmedgeLLVM
  PUBLIC
  ${PROJECT_BINARY_DIR}/include
)

include(CheckCXXSourceCompiles)
set(CMAKE_REQUIRED_LINK_OPTIONS "-Wl,-lc,--exclude-libs=libc.a")
check_cxx_source_compiles("int main(){}" SUPPORT_EXCLUDE_LIBS)

if(SUPPORT_EXCLUDE_LIBS)
  file(GLOB LLD_ALL_LIBS ${LLVM_LIBRARY_DIR}/liblld*.a)
  list(TRANSFORM LLD_ALL_LIBS REPLACE "^.*/" "")
  string(JOIN : LLD_ALL_LIBS_COLON ${LLD_ALL_LIBS})
  if(NOT LLD_ALL_LIBS_COLON STREQUAL "")
    target_link_options(wasmedgeLLVM
      PUBLIC
      "SHELL:-Wl,--exclude-libs=${LLD_ALL_LIBS_COLON}"
    )
  endif()
endif()

=== debian/control ===
Source: wasmedge
Section: web
Priority: optional
Maintainer: Ubuntu Developers <ubuntu-devel-discuss@lists.ubuntu.com>
XSBC-Original-Maintainer: Faidon Liambotis <paravoid@debian.org>
Rules-Requires-Root: no
Build-Depends:
 debhelper-compat (= 13),
 cmake,
 libspdlog-dev,
 llvm-dev,
 liblld-dev,
 lowdown,
Standards-Version: 4.7.0
Homepage: https://wasmedge.org/
Vcs-Browser: https://salsa.debian.org/debian/wasmedge
Vcs-Git: https://salsa.debian.org/debian/wasmedge.git

Package: wasmedge
Architecture: amd64 arm64
Depends:
 ${shlibs:Depends},
 ${misc:Depends},
 libwasmedge0 (= ${binary:Version}),
Description: standalone runtime for WebAssembly
 WasmEdge is a lightweight, high-performance, and extensible WebAssembly
 runtime for cloud native, edge, and decentralized applications.
 .
 It powers serverless apps, embedded functions, microservices, smart contracts,
 and IoT devices.
 .
 This package provides the general WASM runtime ("wasmedge run") as well as the
 ahead-of-time WASM compiler ("wasmedge compile").

Package: libwasmedge0
Section: libs
Architecture: amd64 arm64
Multi-Arch: same
Depends:
 ${shlibs:Depends},
 ${misc:Depends},
Description: standalone runtime for WebAssembly (C API shared library)
 WasmEdge is a lightweight, high-performance, and extensible WebAssembly
 runtime for cloud native, edge, and decentralized applications.
 .
 It powers serverless apps, embedded functions, microservices, smart contracts,
 and IoT devices.
 .
 This package provides the C API shared library.

Package: libwasmedge-dev
Section: libdevel
Architecture: amd64 arm64
Multi-Arch: same
Depends:
 ${misc:Depends},
 libwasmedge0 (= ${binary:Version}),
Description: standalone runtime for WebAssembly (development headers)
 WasmEdge is a lightweight, high-performance, and extensible WebAssembly
 runtime for cloud native, edge, and decentralized applications.
 .
 It powers serverless apps, embedded functions, microservices, smart contracts,
 and IoT devices.
 .
 This package provides the C API shared library development headers.

# A docs package for the book can be generated after mdBook is packaged for
# Debian; see #1004481 for the RFP

=== debian/watch ===
version=4
opts="\
repacksuffix=+dfsg,\
dversionmangle=auto,\
uversionmangle=s/-(alpha|beta|rc)\.?/~$1/,\
searchmode=plain \
" \
https://api.github.com/repos/WasmEdge/WasmEdge/releases \
https://github.com/WasmEdge/WasmEdge/releases/download/?[\d\w\.-]+/WasmEdge-@ANY_VERSION@-src@ARCHIVE_EXT@

## wasmedge 0.16.0+dfsg

=== lib/api/CMakeLists.txt ===
--- 
+++ 
@@ -63,6 +63,19 @@
 
 set(WASMEDGE_CAPI_HEADERS
   ${CMAKE_CURRENT_SOURCE_DIR}/../../include/api/wasmedge/wasmedge.h
+  ${CMAKE_CURRENT_SOURCE_DIR}/../../include/api/wasmedge/wasmedge_ast.h
+  ${CMAKE_CURRENT_SOURCE_DIR}/../../include/api/wasmedge/wasmedge_basic.h
+  ${CMAKE_CURRENT_SOURCE_DIR}/../../include/api/wasmedge/wasmedge_compiler.h
+  ${CMAKE_CURRENT_SOURCE_DIR}/../../include/api/wasmedge/wasmedge_configure.h
+  ${CMAKE_CURRENT_SOURCE_DIR}/../../include/api/wasmedge/wasmedge_context.h
+  ${CMAKE_CURRENT_SOURCE_DIR}/../../include/api/wasmedge/wasmedge_deprecated.h
+  ${CMAKE_CURRENT_SOURCE_DIR}/../../include/api/wasmedge/wasmedge_execution.h
+  ${CMAKE_CURRENT_SOURCE_DIR}/../../include/api/wasmedge/wasmedge_experimental.h
+  ${CMAKE_CURRENT_SOURCE_DIR}/../../include/api/wasmedge/wasmedge_instance.h
+  ${CMAKE_CURRENT_SOURCE_DIR}/../../include/api/wasmedge/wasmedge_plugin.h
+  ${CMAKE_CURRENT_SOURCE_DIR}/../../include/api/wasmedge/wasmedge_tools.h
+  ${CMAKE_CURRENT_SOURCE_DIR}/../../include/api/wasmedge/wasmedge_value.h
+  ${CMAKE_CURRENT_SOURCE_DIR}/../../include/api/wasmedge/wasmedge_vm.h
   ${CMAKE_CURRENT_BINARY_DIR}/../../include/api/wasmedge/version.h
   ${CMAKE_CURRENT_BINARY_DIR}/../../include/api/wasmedge/enum.inc
   ${CMAKE_CURRENT_BINARY_DIR}/../../include/api/wasmedge/enum_configure.h
@@ -86,7 +99,6 @@
   target_link_libraries(wasmedgeCAPI
     PUBLIC
     wasmedgeAOT
-    wasmedgeLLVM
   )
 endif()
 
@@ -98,7 +110,7 @@
 
 if(WASMEDGE_BUILD_SHARED_LIB)
   wasmedge_add_library(wasmedge_shared SHARED
-    ../../include/api/wasmedge/wasmedge.h
+    ${CMAKE_CURRENT_SOURCE_DIR}/../../include/api/wasmedge/wasmedge.h
   )
 
   set_target_properties(wasmedge_shared PROPERTIES
@@ -119,12 +131,8 @@
   endif()
 
   target_link_libraries(wasmedge_shared
-    PRIVATE
+    PUBLIC
     wasmedgeCAPI
-  )
-  target_link_libraries(wasmedge_shared
-    PUBLIC
-    spdlog::spdlog
   )
 
   target_include_directories(wasmedge_shared
@@ -136,11 +144,14 @@
   install(TARGETS wasmedge_shared
     LIBRARY DESTINATION ${CMAKE_INSTALL_LIBDIR}
     PUBLIC_HEADER DESTINATION ${CMAKE_INSTALL_INCLUDEDIR}/wasmedge
+    ARCHIVE COMPONENT WasmEdge
+    LIBRARY COMPONENT WasmEdge
+    RUNTIME COMPONENT WasmEdge
   )
 endif()
 
 if(WASMEDGE_BUILD_STATIC_LIB)
-
+  wasmedge_add_static_lib_component_command(fmt::fmt)
   wasmedge_add_static_lib_component_command(spdlog::spdlog)
   wasmedge_add_static_lib_component_command(wasmedgeSystem)
   wasmedge_add_static_lib_component_command(wasmedgeCommon)
@@ -152,7 +163,7 @@
   wasmedge_add_static_lib_component_command(wasmedgeHostModuleWasi)
   wasmedge_add_static_lib_component_command(wasmedgePlugin)
   # BUILTIN-PLUGIN: Temporary add the wasi-logging plugin here until the new
-  # plugin architecture ready in 0.15.0.
+  # plugin architecture ready in the future.
   wasmedge_add_static_lib_component_command(wasmedgePluginWasiLogging)
   wasmedge_add_static_lib_component_command(wasmedgeVM)
   wasmedge_add_static_lib_component_command(wasmedgeDriver)
@@ -195,8 +206,13 @@
 
   install(FILES ${CMAKE_CURRENT_BINARY_DIR}/libwasmedge.a
     DESTINATION ${CMAKE_INSTALL_LIBDIR}
-  )
+    COMPONENT WasmEdge
+  )
+endif()
+
+if(WASMEDGE_BUILD_STATIC_LIB OR WASMEDGE_BUILD_SHARED_LIB)
   install(FILES ${WASMEDGE_CAPI_HEADERS}
     DESTINATION ${CMAKE_INSTALL_INCLUDEDIR}/wasmedge
-  )
-endif()
+    COMPONENT WasmEdge
+  )
+endif()

=== lib/common/CMakeLists.txt ===
--- 
+++ 
@@ -4,6 +4,7 @@
 wasmedge_setup_spdlog()
 
 wasmedge_add_library(wasmedgeCommon
+  hash.cpp
   hexstr.cpp
   spdlog.cpp
   errinfo.cpp

=== lib/driver/CMakeLists.txt ===
--- 
+++ 
@@ -24,25 +24,10 @@
   )
 endif()
 
-if(WASMEDGE_USE_LLVM)
-  target_link_libraries(wasmedgeDriver
-    PRIVATE
-    wasmedgeLoader
-    wasmedgeCommon
-    wasmedgePO
-    wasmedgeVM
-    wasmedgeAOT
-    wasmedgeLLVM
-  )
-else()
-  target_link_libraries(wasmedgeDriver
-    PRIVATE
-    wasmedgeLoader
-    wasmedgeCommon
-    wasmedgePO
-    wasmedgeVM
-  )
-endif()
+target_link_libraries(wasmedgeDriver
+  PUBLIC
+  wasmedgeVM
+)
 
 if(WASMEDGE_USE_LLVM)
   target_compile_definitions(wasmedgeDriver

=== debian/changelog ===
wasmedge (0.16.0+dfsg-1) unstable; urgency=medium

  * New upstream release.
    - Addresses a memory.h checkAccessBound() vulnerability, CVE-2025-69261.
      (Closes: #1124376)
    - Remove all backported patches from debian/patches.
    - Remove Files-Excluded for files that were removed upstream.
    - Update debian/copyright with removed files & new copyright years.
    - Add new symbols to libwasmedge0.symbols.
  * Update the capi-wasi-env and capi-mandelbrot autopkgtests to accommodate
    upstream changes.

 -- Faidon Liambotis <paravoid@debian.org>  Sat, 03 Jan 2026 11:01:56 +0200

wasmedge (0.14.1+dfsg-4) unstable; urgency=medium

  * Acknowledge NMUs with gratitude to Fabian Grünbichler, Destiny Mora and
    Matthias Klose.
  * d/patches:
    - Add missing metadata to the LLVM 21 backported patch.
    - Add the DEP-3 Origin field to all upstream patches.
    - Refresh all patches.
  * capi-wasi-env: use rust-lld via rust-llvm, removing a workaround. Thanks
    to Fabian Grünbichler.
  * Fix an autopkgtest regression with LLVM 21, by adjusting the features
    flags of the mandelbrot-set-in-threads example. Thanks to Fabian
    Grünbichler for providing the patch and offering to NMU.
    (Closes: #1122878)
  * Update debian/watch to version 5.
  * Bump Standards-Version to 4.7.3.
    - Remove Priority: optional, as it is now dpkg's default.

 -- Faidon Liambotis <paravoid@debian.org>  Mon, 29 Dec 2025 17:20:12 +0200

wasmedge (0.14.1+dfsg-3.2) unstable; urgency=medium

  * Non-maintainer upload.
  * Fix FTBFS in questing due to LLVM 20. LP: #2113496 (Destiny Mora).
    - Remove-LLVMX86_MMXTypeKind-in-LLVM-20.patch.
  * Fix build with LLVM 21 (patch taken from upstream). Closes: #1122609.

 -- Matthias Klose <doko@debian.org>  Sat, 13 Dec 2025 10:07:28 +0100
